Getting Started with MultilineTextBox Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the MultilineTextBox module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.multilinetextbox.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-multiline-text-box id="multilinetextbox"></smart-multiline-text-box>

    Host container (id matches appendTo on Smart.MultilineTextBox):

    <div id="multilinetextboxContainer"></div>

  5. Initialize after the module loads: define a const multilinetextboxOptions object, then either bind with Smart('#multilinetextbox', ...) on the semantic tag or use new Smart.MultilineTextBox({ ...multilinetextboxOptions, appendTo: '#multilinetextboxContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.multilinetextbox.js';
    
    	const multilinetextboxOptions = { value: "Peter Brown" };
    
    	// Option A - semantic <smart-multiline-text-box> with id="multilinetextbox"
    	Smart('#multilinetextbox', class {
    		get properties() {
    			return multilinetextboxOptions;
    		}
    	});
    
    	// Option B - host div id="multilinetextboxContainer"
    	// const multilinetextboxInstance = new Smart.MultilineTextBox({
    	// 	...multilinetextboxOptions,
    	// 	appendTo: '#multilinetextboxContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myMultilineTextBox = new Smart.MultilineTextBox('#multilinetextbox', multilinetextboxOptions);
    	// document.body.appendChild(myMultilineTextBox);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.MultilineTextBox('#multilinetextbox', multilinetextboxOptions) with appendChild, and document.createElement('smart-multiline-text-box') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.MultilineTextBox({ ...options, appendTo: '#...' }); new Smart.MultilineTextBox('#multilinetextbox', multilinetextboxOptions) plus appendChild on the returned element; and document.createElement('smart-multiline-text-box') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myMultilineTextBox = new Smart.MultilineTextBox('#multilinetextbox', multilinetextboxOptions)):

	const multilinetextboxOptions = { value: "Peter Brown" };
	const myMultilineTextBox = new Smart.MultilineTextBox('#multilinetextbox', multilinetextboxOptions);
	document.body.appendChild(myMultilineTextBox);
	

Create with document.createElement('smart-multiline-text-box'), assign properties (same as any custom element), then append:

	const multilinetextboxOptions = { value: "Peter Brown" };
	const multilinetextbox = document.createElement('smart-multiline-text-box');
	Object.assign(multilinetextbox, multilinetextboxOptions);
	document.body.appendChild(multilinetextbox);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.multilinetextbox.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const multilinetextboxOptions = { value: "Peter Brown" };
		const multilinetextbox = new Smart.MultilineTextBox({
			...multilinetextboxOptions,
			appendTo: '#multilinetextboxContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('multilinetextbox-container');
container.appendChild(multilinetextbox);
	

Remove from the DOM:

multilinetextbox.remove();
	

Set a property:

multilinetextbox.disabled = true;
multilinetextbox.theme = 'dark';
	

Get a property value:

const isDisabled = multilinetextbox.disabled;
const currentTheme = multilinetextbox.theme;
	

Invoke a method:

multilinetextbox.refresh();
multilinetextbox.focus();
	

Add event listener:

multilinetextbox.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.oldValue);
});
	

Remove event listener:

const handleMultilineTextBoxEvent = (event) => {
    console.log('change triggered:', event.detail.oldValue);
};

multilinetextbox.addEventListener('change', handleMultilineTextBoxEvent);
multilinetextbox.removeEventListener('change', handleMultilineTextBoxEvent);
	

Accessibility

The MultilineTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular MultilineTextBox - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/multilinetextbox/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import MultilineTextBoxModule from smart-webcomponents-angular/multilinetextbox: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { MultilineTextBoxModule } from 'smart-webcomponents-angular/multilinetextbox';

4 Root component (standalone)

Add MultilineTextBoxModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { MultilineTextBoxComponent } from 'smart-webcomponents-angular/multilinetextbox';

import { MultilineTextBoxModule } from 'smart-webcomponents-angular/multilinetextbox';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ MultilineTextBoxModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('multilinetextbox', { read: MultilineTextBoxComponent, static: false }) multilinetextbox!: MultilineTextBoxComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-multiline-text-box as needed:

 <smart-multiline-text-box #multilinetextbox [enterKeyBehavior]="'newLine'" [selectAllOnFocus]="true" [autoFocus]="true"
    [placeholder]="'smart Text Area'"></smart-multiline-text-box>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put MultilineTextBoxModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put MultilineTextBoxModule from smart-webcomponents-angular/multilinetextbox on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { MultilineTextBoxModule } from 'smart-webcomponents-angular/multilinetextbox';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, MultilineTextBoxModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The MultilineTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.